<?php
	@ob_start();
	include 'include/functions/header.php';
?>
<html lang="<?php print $language_code; ?>">
	<head>	
	
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta charset="UTF-8" />

		<title><?php print $site_title.' - '.$title; if($offline) print ' - '.$lang['server-offline']; ?></title>
		
		<link type="text/css" rel="stylesheet" href="<?php print $site_url; ?>css/style.css" />
		<link type="text/css" rel="stylesheet" href="<?php print $site_url; ?>css/font-awesome.min.css" />
		<link href='https://fonts.googleapis.com/css?family=Ubuntu:400,500,700,300,400italic' rel='stylesheet' type='text/css'>
		<link rel="stylesheet" href="<?php print $site_url; ?>css/superslides.css">
		
		<link rel="shortcut icon" href="<?php print $site_url; ?>img/favicon.ico" />

		<script src="<?php print $site_url; ?>js/jquery.superslides.js" type="text/javascript" charset="utf-8"></script>
		<script src="<?php print $site_url; ?>js/datatables.js"></script>
		<script src="<?php print $site_url; ?>js/main.js"></script>
		<script src="<?php print $site_url; ?>js/tether.min.js"></script>
		<script src="<?php print $site_url; ?>js/bootstrap.min.js"></script>
		<script type="text/javascript" src="<?php print $site_url; ?>js/jquery-2.2.4.min.js"></script>
	</head>
	<body>
		<header>
			<nav id="head_wrap">
				<div class="servername">
					<?php print $site_title ?>
				</div>
				<ul>
					<li><a target="_self" href="?lang=ro">Română</a></li>
					<li class="last"><a target="_self" href="?lang=en">English</a></li>
				</ul>
			</nav>
		</header>
		<div id="wrapper">
			<a id="logo" href="<?php print $site_url; ?>">
				<img src="<?php print $site_url; ?>img/images/logo.png" alt=""/>
			</a>
		
			<nav id="mainnav">
				<ul>
					<li><a href="<?php print $site_url; ?>"><?php print $lang['home']; ?></a></li>
					<li><a href="<?php print $site_url; ?>users/register"><?php print $lang['register']; ?></a></li>
					<li><a href="<?php print $site_url; ?>ranking/players"><?php print $lang['players']; ?></a></li>
					<li><a href="<?php print $site_url; ?>ranking/guilds"><?php print $lang['guilds']; ?></a></li>
					<li><a href="#"><?php print $lang['itemshop']; ?></a></li>
					<li><a href="#">Suport</a></li>
					<li><a href="#">Forum</a></li>
				</ul>
			</nav>
			<main>
				<article>
					<div class="wide-container">
						<div id="slides">
							<ul class="slides-container">
								<li>
									<div class="slide_text">Lorem Ipsum dolor sit amet</div>
									<img src="<?php print $site_url; ?>img/images/slide1.png" alt="">
								</li>
								<li>
									<div class="slide_text">Lorem Ipsum dolor sit amet2</div>
									<img src="<?php print $site_url; ?>img/images/slide2.png" alt="">
								</li>
								<li>
									<div class="slide_text">Lorem Ipsum dolor sit amet2</div>
									<img src="<?php print $site_url; ?>img/images/slide2.png" alt="">
								</li>
								<li>
									<div class="slide_text">Lorem Ipsum dolor sit amet2</div>
									<img src="<?php print $site_url; ?>img/images/slide2.png" alt="">
								</li>
								<li>
									<div class="slide_text">Lorem Ipsum dolor sit amet2</div>
									<img src="<?php print $site_url; ?>img/images/slide2.png" alt="">
								</li>
							</ul>

							<nav class="slides-navigation">
								<a href="#" class="next"></a>
								<a href="#" class="prev"></a>
							</nav>
						</div>
					</div>
					<h1><?php print $site_title ?></h1>
					<div class="content">
						<?php include 'pages/'.$page.'.php'; ?>
					</div>
					
				</article>
				<aside>
					<div class="sb_box" style="min-height:0px;">
						<h3><center><?php print $lang['user-panel']; ?></center></h3>
						<div class="sb_line"></div>

							<?php if($offline || !$database->is_loggedin()) { ?>

								<center><form class="form" role="form" method="post" action="<?php print $site_url; ?>users/login" accept-charset="UTF-8" id="login-nav">

									<div class="form-group">

										<input type="text" name="username" pattern=".{5,64}" maxlength="64" class="form-control" placeholder="<?php print $lang['user-name-or-email']; ?>" autocomplete="off" <?php if($offline) print 'disabled'; else print 'required'; ?>>

									</div>

									<div class="form-group">

										<input type="password" name="password" pattern=".{5,16}" maxlength="16" class="form-control" placeholder="<?php print $lang['password']; ?>" <?php if($offline) print 'disabled'; else print 'required'; ?>>

									</div>

									<div class="form-group">

										<input type="submit" class="btn btn-success btn-block" value="<?php print $lang['login']; ?>"<?php if($offline) print ' disabled'; ?>>

									</div>

								</form></center>

							<?php if(!$offline) { ?>

								<br><center><a href="<?php print $site_url; ?>users/lost"><?php print $lang['forget-password']; ?></a></center>

							<?php } ?>


							<?php } else { ?>

								<nav id="subnav" style="margin-left:0px;">
									<ul style="margin-left:-27px;">
										<?php if($web_admin) { ?>

										<li><a href="<?php print $site_url; ?>admin"><?php print $lang['administration']; ?><?php if(checkUpdate(officialVersion())) print ' <span class="tag tag-info tag-pill float-xs-right">'.$lang['update-available'].'</span>'; ?></a></li>

										<?php } ?>

										<li><a href="<?php print $site_url; ?>user/administration"><?php print $lang['account-data']; ?></a></li>

										<?php if($item_shop!="") { ?>

										<li><a target='_blank' href="<?php print $item_shop; ?>"><?php print $lang['item-shop']; ?></a></li>

										<?php } ?>

										<li><a href="<?php print $site_url; ?>users/logout"><?php print $lang['logout']; ?></a></li>

										<?php if($web_admin) { ?>

										<li><a>web_admin <?php print $web_admin; ?></a></li>

										<?php } ?>
									</ul>
								</nav>

							<?php } ?>
					</div>
					<a class="sb_btn" href="<?php print $site_url; ?>download">
						<?php print $lang['download']; ?>
					</a>
					<nav id="subnav">
						<ul>
							<li><a href="<?php print $site_url; ?>"><?php print $lang['home']; ?></a></li>
							<li><a href="<?php print $site_url; ?>users/register"><?php print $lang['register']; ?></a></li>
						</ul>
					</nav>
					<div class="sb_box">
						<h3><center><?php print $lang['ranking-players']; ?></center></h3>
						<div class="sb_line"></div>
							<table>
								<thead>
									<tr>
										<th></th>
										<th>#</th>
										<th><?php print $lang['name']; ?></th>
										<th><?php print $lang['empire']; ?></th>
									</tr>
								</thead>
								<tbody>
									<?php
									if(!$offline) {
										$top = array();
										$top = top10players();
										
										$i=1;
										
										foreach($top as $player)
										{
									?>
									<tr>
										<td></td>
										<th scope="row"><strong><?php print $i++; ?></strong></th>
										<td><?php print $player['name']; ?></td>
										<td><img src="<?php print $site_url; ?>img/images/empire/<?php print $empire=get_player_empire($player['account_id']); ?>.jpg" alt="<?php print emire_name($empire); ?>" title="<?php print emire_name($empire); ?>"></td>
									</tr>
									<?php }
									} else print $offline_players;
									?>
								</tbody>
							</table>
						<br/>
						<a href="ranking/players/" class="btn_m">
							<?php print $lang['ranking-complete']; ?>
						</a>
						<div class="clear"></div>
					</div>
					<div class="sb_box">
						<h3><center><?php print $lang['ranking-guilds']; ?></center></h3>
						<div class="sb_line"></div>
							<table>
								<thead>
									<tr>
										<th></th>
										<th>#</th>
										<th><?php print $lang['name']; ?></th>
										<th><?php print $lang['empire']; ?></th>
									</tr>
								</thead>
								<tbody>
									<?php
									if(!$offline) {
										$top = array();
										$top = top10guilds();
										
										$i=1;
										
										foreach($top as $guild)
										{
									?>
									<tr>
										<td></td>
										<th scope="row"><strong><?php print $i++; ?></strong></th>
										<td><?php print $guild['name']; ?></td>
										<td><img src="<?php print $site_url; ?>img/images/empire/<?php print $empire=get_guild_empire($guild['master']); ?>.jpg" alt="<?php print emire_name($empire); ?>" title="<?php print emire_name($empire); ?>"/></td>
									</tr>
									<?php }
									} else print $offline_guilds;
									?>
								</tbody>
							</table>
						<br/>
						<a href="ranking/guilds/" class="btn_m">
							<?php print $lang['ranking-complete']; ?>
						</a>
						<div class="clear"></div>
					</div>
				</aside>
			</main>
			<footer>
				<div class="cr">
					<font color="gold"><span>Powered by <a href="http://metin2cms.cf/">Metin2CMS <?php print $mt2cms; ?></a>.<br>
					Copyright <?php echo date('Y');?> &copy; <a href="#"><?php print $site_title ?></a>. All Rights reserved.<br>
					Template by nybu at <a href="http://www.flying-men.de">www.flying-men.de</a></span></font>
				</div>
				<div class="nybucms">
					<div class="powered"><font color="gold">Website coded by</div>
					<a href="http://www.twix-work.com/"><span>TWIX-WORK</span></a></font>
				</div>
			</footer>
			
		</div>
		<div id="footnav">
			<ul>
				<li><a href="<?php print $site_url; ?>"><?php print $lang['home']; ?></a></li>
				<li><a href="<?php print $site_url; ?>users/register"><?php print $lang['register']; ?></a></li>
				<li><a href="<?php print $site_url; ?>ranking/players"><?php print $lang['players']; ?></a></li>
				<li><a href="<?php print $site_url; ?>ranking/guilds"><?php print $lang['guilds']; ?></a></li>
				<li><a href="#"><?php print $lang['itemshop']; ?></a></li>
				<li><a href="#">Suport</a></li>
				<li class="last"><a href="#">Forum</a></li>
			</ul>
		</div>
	</body>
</html>